package require tidy
package require tdom
#
# некоторые страницы (в т.ч. mql5) не поддаются даже tidy если не вырезать скрипты.
#

# удаление <script .... </noscript>
proc remove_scripts { html } {
	set out ""
	set pos 0
	while 1 {
		set begin [ string first "<script" $html $pos ]
		if { $begin < 0 } {
			set out "${out}[ string range $html $pos end ]"
			break
		}
		set out "${out}[ string range $html $pos [ expr $begin - 1 ] ]"
		set end [ string first "</script>" $html $pos ]
		if { $end < 0 } {
			break
		} else {
			set pos [ expr { $end + [ string length "</script>" ] } ]
		}
	}
	return $out
}
# удаление <head .... </nohead>
proc remove_head { html } {
	set out ""
	set begin [ string first "<head" $html ]
	if { $begin < 0 } {
		return $html	
	}
	set out "[ string range $html 0 [ expr $begin - 1 ] ]<head>"
	set end [ string first "</head>" $html $begin ]
	set pos [ expr { $end + [ string length "</head>" ] } ]
	set out "${out}</head>[string range $html $pos end ]"
	return $out
}

# исполнение xpath (и вылечивание страниц. предварительно)
proc html_xpath { brokenHtml xpath {as asText} } {
	set result ""
	set tmpname ""
	set tmp ""
	try {
		set noscript [ remove_scripts [ remove_head $brokenHtml ] ]
		set tmp [ file tempfile tmpname ]
		#puts $tmp $noscript
		close $tmp
		#puts "invoke tidy"
		catch { exec -- tidy -q -asxhtml -raw << $noscript > $tmpname 2> NUL }
		#puts "end tidy"
	} on error err {
		#puts $err
		set html $brokenHtml
	}
	if { [ file size $tmpname ] > 0 } {
		set f [ open $tmpname "r" ]
		set html [ read $f ]
		close $f
	}
	set document ""
	#puts "document processing $xpath"
	try {
		set document [ dom parse $html -html ]
		set root [ $document documentElement ]
		
		set nodes [ $root selectNodes $xpath ]
		foreach node $nodes {
			#puts $node
			lappend result [ $node asText ]
		}
	} on error err {
		#puts "xpath err: $err"
	} finally {
		
		if { $document!= "" } {
			catch { rename $document "" }
		}
	}
	return $result
}

