package provide MTData 0.1
# энумераторы MetaTrader
# и процедуры работы с данными

proc make_dict { names args } {
	set result {}
	foreach name $names value $args {
		dict set result {*}$name $value
	}
	return $result
}
proc make_json { names args } {
	set result {{}}
	foreach name $names value $args {
		rl_json::json set result {*}$name $value
	}
	return $result
}
proc ToObj { fmt names args } {
	if { $fmt == 0 } { return $args }
	if { $fmt == 1 } { return [ make_dict $names {*}$args ] }
	if { $fmt == 2 } { return [ make_json $names {*}$args ] }
	return {}
}		
proc FromObj { value {names {}} { defaults {} } } {
	if { [ string is double $value ] } {
		return $value
	}
	if { [ string range $value 0 1 ] == "{\"" && [ string range $value end end ] =="}" && [ rl_json::json valid $value ] } {
		# объект json
		if { $names == {} } {
			# если имена не заданы - то в алфавитном+словарном порядке
			set names [ lsort -dictionary [ rl_json::json keys $value ] ]
			set defaults {}
		}
		set result {}
		foreach name $names def $defaults {
			lappend result [ rl_json::json get -default $def $value $name ]
		}
		return $result
	} 
	if { [ string range $value 0 0 ] == "\[" && [ string range $value end end ] =="\]" && [ rl_json::json valid $value ] } {
		# список json
		return [ rl_json::json get $value ]
	}
	set total [ llength $value ]
	if { $total < 2 } {
		return $values
	}
	set first [ lindex $value 0 ]
	if { $first == {} || [ string is double $first ] || [ llength $first ] > 1 } {
		return $values
	}
	set ident {^[A-Za-z_][[A-Za-z0-9_]*$}
	if { [ expr { $totals % 2 } ] == 0 && [ llength [ dict get $value ] ] == $total && [ regexp $ident $first ] } {
		# кол-во элементов чётно, нет дублирующих ключей
		# значит values - словарь
		if { $names == {} } {
			set names [ lsort -dictionary [ dict keys $values ] ]
			set defaults {}
		}
		set result {}
		foreach name $names def $defaults {
			if { ! [ dict exists $value $name ] } {
				lappend result $def
			} else {
				lappend result [ dict get $value $name ]
			}
		}
	}
	return $values
}
